/* 
 * Leaflet Panel Layers v0.8.6 - 2016-11-28 
 * 
 * Copyright 2016 Stefano Cudini 
 * stefano.cudini@gmail.com 
 * http://labs.easyblog.it/ 
 * 
 * Licensed under the MIT license. 
 * 
 * Demos: 
 * http://labs.easyblog.it/maps/leaflet-panel-layers/ 
 * 
 * Source: 
 * git@github.com:stefanocudini/leaflet-panel-layers.git 
 * 
 */
(function(){L.Control.PanelLayers=L.Control.Layers.extend({includes:L.Mixin.Events,options:{compact:!1,collapsed:!1,autoZIndex:!0,collapsibleGroups:!1,buildItem:null,title:"",className:"",position:"topright"},initialize:function(a,b,c){L.setOptions(this,c),this._layers={},this._groups={},this._items={},this._layersActives=[],this._lastZIndex=0,this._handlingClick=!1,this.className="leaflet-panel-layers";var d,e,f;for(d in a)if(a[d].group&&a[d].layers){f=a[d].collapsed||!1;for(e in a[d].layers)this._addLayer(a[d].layers[e],!1,a[d].group,f)}else this._addLayer(a[d],!1);for(d in b)if(b[d].group&&b[d].layers){f=b[d].collapsed||!1;for(e in b[d].layers)this._addLayer(b[d].layers[e],!0,b[d].group,f)}else this._addLayer(b[d],!0)},onAdd:function(a){var b=this;for(var c in this._layersActives)a.addLayer(this._layersActives[c]);return L.Control.Layers.prototype.onAdd.call(this,a),this._map.on("resize",function(a){b._updateHeight(a.newSize.y)}),this._container},addBaseLayer:function(a,b,c){return a.name=b||a.name||"",this._addLayer(a,!1,c),this._update(),this},addOverlay:function(a,b,c){return a.name=b||a.name||"",this._addLayer(a,!0,c),this._update(),this},removeLayer:function(a){var b=a.hasOwnProperty("layer")?this._layerFromDef(a):a;return this._map.removeLayer(b),L.Control.Layers.prototype.removeLayer.call(this,b),this},clearLayers:function(){for(var a in this._layers)this.removeLayer(this._layers[a])},_layerFromDef:function(a){for(var b in this._layers)if(this._layers[b].name===a.name)return this._layers[b].layer},_update:function(){this._groups={},this._items={},L.Control.Layers.prototype._update.call(this)},_instantiateLayer:function(a){return a instanceof L.Class?a:a.type&&a.args?this._getPath(L,a.type).apply(L,a.args):void 0},_addLayer:function(a,b,c,d){a.hasOwnProperty("layer")&&(a.layer=this._instantiateLayer(a.layer)),a.hasOwnProperty("id")||(a.id=L.stamp(a.layer)),a.active&&this._layersActives.push(a.layer),this._layers[a.id]=L.Util.extend(a,{collapsed:d,overlay:b,group:c}),this.options.autoZIndex&&a.layer.setZIndex&&(this._lastZIndex++,a.layer.setZIndex(this._lastZIndex))},_createItem:function(a){var b,c,d,e=this;b=L.DomUtil.create("div",this.className+"-item"+(a.active?" active":"")),d=this._map.hasLayer(a.layer),a.overlay?(c=L.DomUtil.create("input",this.className+"-selector"),c.type="checkbox",c.defaultChecked=d):c=this._createRadioElement("leaflet-base-layers",d),c.value=L.stamp(a.layer),c._layer=a,L.DomEvent.on(c,"click",function(a){e._onInputClick(),a.target.checked?e.fire("panel:selected",a.target._layer):e.fire("panel:unselected",a.target._layer)},this);var f=L.DomUtil.create("label",this.className+"-title");if(f.innerHTML="<span>"+(a.name||"")+"<span>",a.icon){var g=L.DomUtil.create("i",this.className+"-icon");"string"==typeof a.icon?g.innerHTML=a.icon||"":g.appendChild(a.icon),f.appendChild(g)}if(f.appendChild(c),b.appendChild(f),this.options.buildItem){var h=this.options.buildItem.call(this,a);if("string"==typeof h){var i=L.DomUtil.create("div");i.innerHTML=h,b.appendChild(i.firstChild)}else b.appendChild(h)}return this._items[c.value]=b,b},_createRadioElement:function(a,b){var c='<input type="radio" class="'+this.className+'-selector" name="'+a+'"';b&&(c+=' checked="checked"'),c+="/>";var d=document.createElement("div");return d.innerHTML=c,d.firstChild},_addItem:function(a){var b,c=a.overlay?this._overlaysList:this._baseLayersList;if(a.group){if(a.group.hasOwnProperty("name")||(a.group={name:a.group}),!this._groups[a.group.name]){var d=!1;a.collapsed===!0&&(d=!0),this._groups[a.group.name]=this._createGroup(a.group,d)}c.appendChild(this._groups[a.group.name]),c=this._groups[a.group.name]}return b=this._createItem(a),c.appendChild(b),b},_createGroup:function(a,b){var c,d,e,f=this,g=L.DomUtil.create("div",this.className+"-group");return this.options.collapsibleGroups&&(L.DomUtil.addClass(g,"collapsible"),e=L.DomUtil.create("i",this.className+"-icon",g),b===!0?e.innerHTML=" + ":e.innerHTML=" - ",L.DomEvent.on(e,"click",function(){L.DomUtil.hasClass(g,"expanded")?(L.DomUtil.removeClass(g,"expanded"),e.innerHTML=" + "):(L.DomUtil.addClass(g,"expanded"),e.innerHTML=" - "),f._updateHeight()}),b===!1&&L.DomUtil.addClass(g,"expanded")),c=L.DomUtil.create("label",this.className+"-grouplabel",g),d=L.DomUtil.create("span",this.className+"-title",c),d.innerHTML=a.name,g},_onInputClick:function(){var a,b,c,d=this._form.getElementsByClassName(this.className+"-selector"),e=d.length;for(this._handlingClick=!0,a=0;e>a;a++)b=d[a],c=this._layers[b.value],b.checked&&!this._map.hasLayer(c.layer)?(L.DomUtil.addClass(b.parentNode.parentNode,"active"),this._map.addLayer(c.layer)):!b.checked&&this._map.hasLayer(c.layer)&&(L.DomUtil.removeClass(b.parentNode.parentNode,"active"),this._map.removeLayer(c.layer));this._handlingClick=!1,this._refocusOnMap()},_initLayout:function(){var a=this._container=L.DomUtil.create("div",this.className);if(a.setAttribute("aria-haspopup",!0),L.Browser.touch?L.DomEvent.on(a,"click",L.DomEvent.stopPropagation):L.DomEvent.disableClickPropagation(a).disableScrollPropagation(a),L.DomEvent.disableClickPropagation(a),this.options.className&&L.DomUtil.addClass(a,this.options.className),this._form=L.DomUtil.create("form",this.className+"-list"),this._updateHeight(),this.options.compact?L.DomUtil.addClass(a,"compact"):this._form.style.height=this._map.getSize().y+"px",this.options.collapsed){L.Browser.android||L.DomEvent.on(a,"mouseover",this._expand,this).on(a,"mouseout",this._collapse,this);var b=this._layersLink=L.DomUtil.create("a",this.className+"-toggle",a);b.href="#",b.title="Layers",L.Browser.touch?L.DomEvent.on(b,"click",L.DomEvent.stop).on(b,"click",this._expand,this):L.DomEvent.on(b,"focus",this._expand,this),this._map.on("click",this._collapse,this)}else this._expand();if(this._baseLayersList=L.DomUtil.create("div",this.className+"-base",this._form),this._separator=L.DomUtil.create("div",this.className+"-separator",this._form),this._overlaysList=L.DomUtil.create("div",this.className+"-overlays",this._form),this.options.compact||L.DomUtil.create("div",this.className+"-margin",this._form),this.options.title){var c=L.DomUtil.create("label",this.className+"-title");c.innerHTML="<span>"+this.options.title+"</span>",a.appendChild(c)}a.appendChild(this._form)},_updateHeight:function(a){a=a||this._map.getSize().y,this.options.compact?this._form.style.maxHeight=a-30+"px":this._form.style.height=a-30+"px"},_expand:function(){L.DomUtil.addClass(this._container,"expanded")},_collapse:function(){this._container.className=this._container.className.replace("expanded","")},_getPath:function(a,b){var c=b.split("."),d=c.pop(),e=c.length,f=c[0],g=1;if(e>0)for(;(a=a[f])&&e>g;)f=c[g++];return a?a[d]:void 0}}),L.control.panelLayers=function(a,b,c){return new L.Control.PanelLayers(a,b,c)}}).call(this);